<?php
defined( 'ABSPATH' ) || die();
class Diviflash_Module_Manage {
    const INACTIVE_MODULE_KEY = 'difl_inactive_modules';

    /**
     * Fetch/get all Inactive module from DB
     * @return json respons
     */
    public function get_inactive_modules(){
        return  get_option( self::INACTIVE_MODULE_KEY ) ? get_option( self::INACTIVE_MODULE_KEY, [] ) : "[]";
    }

    /**
     * Save Inactive Module list
     *
     * @param array $modles Module array
     */
    public function save_inactive_modules($modules = array()){
        update_option( self::INACTIVE_MODULE_KEY, wp_json_encode($modules) );
    }

    /**
     * All Module store in an array 
     * Each array item have parent, parent name, icon property
     * For Child Module have child, child_name property 
     * Use at Dashboard
     * New Module array item will add when new module developed
     */
	public function all_modules_map(){
        $modules = array(
            array(
                'parent' => 'AdvancedBlurb',
                'parent_name' => 'Advanced Blurb',
                'icon'  => 'img/module-icons/advanced-blurb.svg'
            ),
            array(
                'parent' => 'AdvancedDataTable',
                'parent_name' => 'Advanced Data Table',
                'icon'  => 'img/module-icons/advanceddatatable.svg'
            ),
            array(
                'parent' => 'AdvancedPerson',
                'parent_name' => 'Advanced Person',
                'icon'  => 'img/module-icons/advanced-person.svg'
            ),
            array(
                'parent' => 'AdvancedTab',
                'parent_name' => 'Advanced Tabs',
                'child'  => 'AdvancedTabItem',
                'child_name'  => 'Advanced Tab Item',
                'icon'  => 'img/module-icons/advanced-tabs.svg'
            ),
            array(
                'parent' => 'ImageGallery',
                'parent_name' => 'Advanced Image Gallery',
                'child'=> 'ImageGalleryItem',
                'child_name'=> 'Image Gallery Item',
                'icon' => 'img/module-icons/image-gallery.svg'
            ),
            array(
                'parent' => 'Heading',
                'parent_name' => 'Advanced Heading',
                'icon' => 'img/module-icons/advanced-heading.svg'
            ),
            array(
                'parent' => 'Heading_Anim',
                'parent_name' => 'Animated Heading',
                'icon' => 'img/module-icons/animated-heading.svg'
            ),
            array(
                'parent' => 'BlogCarousel',
                'parent_name' => 'Blog Carousel',
                'child' => 'PostItem',
                'child_name' => 'Post Item',
                'icon' => 'img/module-icons/blogcarousel.svg'
            ),
            array(
                'parent' => 'PostGrid',
                'parent_name' => 'Blog Grid',
                'child' => 'PostItem',
                'child_name' => 'Post Item',
                'icon' => 'img/module-icons/postgrid.svg'
            ),
            array(
                'parent' => 'BusinessHours',
                'parent_name' => 'Business Hours',
                'child'=> 'BusinessHoursItem',
                'child_name'=> 'Business Hours Item',
                'icon' => 'img/module-icons/business-hours.svg'
            ),
            array(
                'parent' => 'CompareImage',
                'parent_name' => 'Before After Image',
                'icon' => 'img/module-icons/image-compare.svg'
            ),
            array(
                'parent' => 'CFSeven',
                'parent_name' => 'C F Seven',
                'icon' => 'img/module-icons/contact-form-7.svg'
            ),
            array(
                'parent' => 'ContentCarousel',
                'parent_name' => 'Content Carousel',
                'child'  => 'ContentCarouselItem',
                'child_name'=> 'Content Carousel Item',
                'icon' => 'img/module-icons/content-carousel.svg'
            ),
            array(
                'parent' => 'DataTable',
                'parent_name' => 'Data Table',
                'child'  => 'DataTableItem',
                'child_name'  => 'Data Table Item',
                'icon' => 'img/module-icons/datatable.svg'
            ),
            array(
                'parent' => 'DualButton',
                'parent_name' => 'Dual Button',
                'icon' => 'img/module-icons/dual-button.svg'
            ),
            array(
                'parent' => 'FlipBox',
                'parent_name' => 'Flip Box',
                'icon' => 'img/module-icons/flip.svg'
            ),
            array(
                'parent' => 'FloatImage',
                'parent_name' => 'Floating Images',
                'child'=> 'FloatImageItem',
                'child_name'=> 'Float Image Item',
                'icon' => 'img/module-icons/float-image.svg'
            ),
            array(
                'parent' => 'HoverBox',
                'parent_name' => 'Hover Box',
                'icon' => 'img/module-icons/hover-box.svg'
            ),
            array(
                'parent' => 'ImageAccordion',
                'parent_name' => 'Image Accordion',
                'child'  => 'ImageAccordionItem',
                'child_name'  => 'Image Accordion Item',
                'icon' => 'img/module-icons/image-accordion.svg'
            ),
            array(
                'parent'      => 'ImageCarousel',
                'parent_name' => 'Image Carousel',
                'child'       => 'ImageCarouselItem',
                'child_name'  => 'Image Carousel Item',
                'icon' => 'img/module-icons/image-carousel.svg'
            ),
            array(
                'parent' => 'ImageHover',
                'parent_name' => 'Image Hover',
                'icon' => 'img/module-icons/image-hover-box.svg'
            ),
            array(
                'parent' => 'ImageMask',
                'parent_name' => 'Image Mask',
                'icon' => 'img/module-icons/image-masking.svg'
            ),
            array(
                'parent' => 'InstagramCarousel',
                'parent_name' => 'Instagram Carousel',
                'icon' => 'img/module-icons/instagram-carousel.svg'
            ),
            array(
                'parent' => 'InstagramGallery',
                'parent_name' => 'Instagram Gallery',
                'icon' => 'img/module-icons/instagram-gallery.svg'
            ),
            array(
                'parent' => 'JustifiedGallery',
                'parent_name' => 'Justified Gallery',
                'icon' => 'img/module-icons/justified-gallery.svg'
            ),
            array(
                'parent' => 'LogoCarousel',
                'parent_name' => 'Logo Carousel',
                'child' => 'LogoCarouselItem',
                'child_name' => 'Logo Carousel Item',
                'icon' => 'img/module-icons/logo-carousel.svg'
            ),
            array(
                'parent' => 'PackeryGallery',
                'parent_name' => 'Packery Gallery',
                'icon' => 'img/module-icons/packery.svg'
            ),
           
            array(
                'parent' => 'TestimonialCarousel',
                'parent_name' => 'Testimonial Carousel',
                'child' => 'TestimonialCarouselItem',
                'child_name' => 'Testimonial Carousel Item',
                'icon' => 'img/module-icons/test-carousel.svg'
            ),
            array(
                'parent' => 'TiltCard',
                'parent_name' => 'Tilt Card',
                'icon' => 'img/module-icons/titlt-box.svg'
            ),
            array(
                'parent' => 'WPForms',
                'parent_name' => 'WP Forms',
                'icon' => 'img/module-icons/wp-form.svg'
            ),     
            array(
                'parent' => 'CptGrid',
                'parent_name' => 'Cpt Grid',
                'child' => 'CptItem',
                'child_name' => 'Cpt Item',
                'icon' => 'img/module-icons/postgrid.svg'
            ),     
        );

        return $modules;
    }

    /**
     * Include all Module files 
     * call register_module() function 
     */
	public function include_module(){
        if ( empty( $this->all_modules_map() ) ) {
            return;
        }
        $all_modules        = $this->all_modules_map();
		$all_parent_modules = array_column($all_modules, 'parent');
		$all_child_modules = array_column($all_modules, 'child');
		$modules = array_merge($all_parent_modules, $all_child_modules );
        if ( empty( $this->get_inactive_modules() ) ) {
            return;
        }
        $all_inactive_modules = json_decode($this->get_inactive_modules());
	
        if ( ! class_exists( 'ET_Builder_Element' ) ) {
            return;
        }

        // include the files that will 
        // used by the module
        require_once( DIFL_MAIN_DIR . '/includes/utils/df_utls.php' );  
        require_once( DIFL_MAIN_DIR . '/includes/classes/df-cpt-taxonomies.php' );
        require_once( DIFL_MAIN_DIR . '/includes/classes/df-acf-fields.php' );
        require_once( DIFL_MAIN_DIR . '/includes/classes/df-acf-data-process.php' );
        
		foreach ( $modules as $key => $module_name ) {
	
			if ( ! in_array( $module_name, $all_inactive_modules) ) {
				$this->register_module( $module_name );
			}
		}
	}

    /**
     * Inculde each module one by one
     *
     * @param String $module_name It come's  from 'parent' property of all_modules_map()  
     */
	protected function register_module( $module_name ) {
		$module_file = DIFL_MAIN_DIR . '/includes/modules/' . $module_name . '/'.$module_name .'.php';

		if ( is_readable( $module_file ) ) {
            require_once $module_file;
		}
	}

}
